//
//  REString.m
//
//  Created by Jérôme Paschoud on 18.11.06.
//	Source available at http://www.spikesoft.ch
//  Copyright 2006 SpikeSoft. All rights reserved.
//
//  Based on the code of David Teare 
//  http://tearesolutions.com/2006/09/how_to_use_regular_expressions_1.html
//

#import <regex.h>
#import "REString.h"
//#define DEBUG


@implementation NSString(AWSRegex)

- (BOOL)matches:(NSString *) regex withSubstring:(NSMutableArray *) substring{
	BOOL result = false;
    regex_t re;
    if (0 == regcomp(&re, regex, REG_EXTENDED)) {
		size_t nmatch = re.re_nsub +1;
		regmatch_t pmatch[nmatch]; 
		if (0 == regexec(&re, [self UTF8String], nmatch, pmatch, 0)) {
			result = true;
			if (substring  != nil){
				int i = 1;
				for (i; i < nmatch; i++){
					if (pmatch[i].rm_so == pmatch[i].rm_eo & pmatch[i].rm_so == -1) {
						// the is no matching charaters for this partial expression
						[substring addObject:@""];
						#ifdef DEBUG
						NSLog(@"-1,-1, ");
						#endif
					}
					else {
						// return the found expressions
						[substring addObject:[[self substringToIndex:pmatch[i].rm_eo] substringFromIndex:pmatch[i].rm_so]];
						#ifdef DEBUG
						NSLog(@"%qd,%qd, %@",pmatch[i].rm_so,pmatch[i].rm_eo,[[self substringToIndex:pmatch[i].rm_eo] substringFromIndex:pmatch[i].rm_so]);
						#endif
					}
				}
			}
		}
    }
    regfree(&re);
    return result;
}
  
@end
